# encoding:utf-8
from __future__ import print_function
import os
from ftplib import FTP
from shutil import copyfile

error = 'error::'
filename = ''
onlineapp = ''
onlineDevice = ''
path = 'home'
deepPath = 'codesys'
destinationPathWin = 'C:\\'+path+'\\'+deepPath+'\\'
destinationPath = '/'+path+'/'+deepPath+'/'

def getAppState():
	global onlineapp, error
	try:
		return onlineapp.application_state
	except:
		return error + 'onlineapp.application_state'

def appIsLoggedIn():
	global onlineapp, error
	try:
		return onlineapp.is_logged_in
	except:
		return error + 'onlineapp.is_logged_in'

def downloadXmlToPlc():
	global onlineDevice, error, destinationPath, destinationPathWin,filename,path,deepPath
	if(os.path.exists('C:/'+path)==False):
		os.makedirs('C:/'+path)
				
	if(os.path.exists('C:/'+path+'/'+deepPath)==False):
		os.makedirs('C:/'+path+'/'+deepPath)
	if(os.path.isfile('C:/'+path+'/'+deepPath+'/'+filename)==True):
		os.remove('C:/'+path+'/'+deepPath+'/'+filename)
	try:
		onlineDevice.download_file( filename, destinationPath + filename, True)
		print("download::" + destinationPath + filename + "::Done")
	except:
		try:
			copyfile(os.getcwd()+ os.sep +filename, destinationPathWin+filename)
			print("download::" + destinationPathWin + filename + "::Done")
		except:
			print (error + "downloadToPlc")

def getXmlFile():
	global filename
	arrPath = projects.primary.path
	arrPath = arrPath.split("\\")
	arrPath.pop()
	os.chdir("\\".join(arrPath))
	print(os.getcwd())
	dirs = os.listdir(os.getcwd())
	for file in dirs:
		tmpfileName,tmpfileExtension = os.path.splitext(file)
		if(tmpfileExtension==".xml"):
			filename = file
			break

def is_file(ftp, filename):
    return ftp.size(filename) is not None

def ftpPrg():
	ftp = FTP('192.168.2.254')     	# connect to host, default port
	ftp.login('root','root')       		# user root, passwd root@
	ftp.set_pasv('true')	       			# setPassive Mode
	ftp.cwd(destinationPath)   		# change into "/var/www/dist/cs3" directory
	try:
		is_file(ftp, filename)
		print ('Delete old File...')
		ftp.delete(filename)
	except:
		print('File not here...')

	print('Copy new File....')
	ftp.storbinary('STOR '+ filename, open(filename,'rb'))		# copy File
	ftp.retrlines('LIST')           			# list directory contents
	ftp.quit()										# destroy

print("--- Elrest Login Start ---")


if not projects.primary:
	print('Please open any Project...')
else: 
	print('Project open')
	getXmlFile()
	if (len(filename) == 0):
		print('XML File not found!')
	else: 
		print (filename)
		app = projects.primary.active_application
		onlineapp = online.create_online_application(app)
		onlineDevice = onlineapp.get_online_device()
		projects.primary.save()
		retVal = appIsLoggedIn()
		if retVal == True:
			print('Logged In')
			appOk = True
		elif retVal == False:
			print('Try to Login')
			onlineapp.login(OnlineChangeOption.Try, True)
			appOk = True
		else:
			print(retVal)
			appOk = False

	appStateOk= False
	if appOk == True:
		retVal = getAppState()
		if retVal == ApplicationState.stop:
			onlineapp.start()
			system.delay(1000)
			appStateOk = True
		elif retVal == ApplicationState.run:
			appStateOk = True
		elif retVal == ApplicationState.unknown:
			print('ApplicationState.unknown')
		elif retVal == ApplicationState.none:
			print('ApplicationState.none')
		else:
			print(retVal)

	if appStateOk == True:
		downloadXmlToPlc()

print("--- Elrest Login Stop ---")